<?php

namespace Geniki\GenikiArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoucherJob GenikiArray
 * @package Geniki
 * @subpackage Arrays
 */
class GenikiArrayOfVoucherJob extends AbstractStructArrayBase
{
    /**
     * The VoucherJob
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Geniki\GenikiStruct\GenikiVoucherJob[]
     */
    public $VoucherJob;
    /**
     * Constructor method for ArrayOfVoucherJob
     * @uses GenikiArrayOfVoucherJob::setVoucherJob()
     * @param \Geniki\GenikiStruct\GenikiVoucherJob[] $voucherJob
     */
    public function __construct(array $voucherJob = array())
    {
        $this
            ->setVoucherJob($voucherJob);
    }
    /**
     * Get VoucherJob value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Geniki\GenikiStruct\GenikiVoucherJob[]|null
     */
    public function getVoucherJob()
    {
        return isset($this->VoucherJob) ? $this->VoucherJob : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucherJob method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucherJob method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherJobForArrayConstraintsFromSetVoucherJob(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoucherJobVoucherJobItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoucherJobVoucherJobItem instanceof \Geniki\GenikiStruct\GenikiVoucherJob) {
                $invalidValues[] = is_object($arrayOfVoucherJobVoucherJobItem) ? get_class($arrayOfVoucherJobVoucherJobItem) : sprintf('%s(%s)', gettype($arrayOfVoucherJobVoucherJobItem), var_export($arrayOfVoucherJobVoucherJobItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoucherJob property can only contain items of type \Geniki\GenikiStruct\GenikiVoucherJob, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoucherJob value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Geniki\GenikiStruct\GenikiVoucherJob[] $voucherJob
     * @return \Geniki\GenikiArray\GenikiArrayOfVoucherJob
     */
    public function setVoucherJob(array $voucherJob = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherJobArrayErrorMessage = self::validateVoucherJobForArrayConstraintsFromSetVoucherJob($voucherJob))) {
            throw new \InvalidArgumentException($voucherJobArrayErrorMessage, __LINE__);
        }
        if (is_null($voucherJob) || (is_array($voucherJob) && empty($voucherJob))) {
            unset($this->VoucherJob);
        } else {
            $this->VoucherJob = $voucherJob;
        }
        return $this;
    }
    /**
     * Add item to VoucherJob value
     * @throws \InvalidArgumentException
     * @param \Geniki\GenikiStruct\GenikiVoucherJob $item
     * @return \Geniki\GenikiArray\GenikiArrayOfVoucherJob
     */
    public function addToVoucherJob(\Geniki\GenikiStruct\GenikiVoucherJob $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Geniki\GenikiStruct\GenikiVoucherJob) {
            throw new \InvalidArgumentException(sprintf('The VoucherJob property can only contain items of type \Geniki\GenikiStruct\GenikiVoucherJob, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoucherJob[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Geniki\GenikiStruct\GenikiVoucherJob|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Geniki\GenikiStruct\GenikiVoucherJob|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Geniki\GenikiStruct\GenikiVoucherJob|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Geniki\GenikiStruct\GenikiVoucherJob|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Geniki\GenikiStruct\GenikiVoucherJob|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoucherJob
     */
    public function getAttributeName()
    {
        return 'VoucherJob';
    }
}
