<?php

namespace Geniki\GenikiStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalculateDayResult GenikiStruct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CalculateDayResult
 * @package Geniki
 * @subpackage Structs
 */
class GenikiCalculateDayResult extends GenikiMethodResult
{
    /**
     * The MinDays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MinDays;
    /**
     * The MaxDays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MaxDays;
    /**
     * Constructor method for CalculateDayResult
     * @uses GenikiCalculateDayResult::setMinDays()
     * @uses GenikiCalculateDayResult::setMaxDays()
     * @param int $minDays
     * @param int $maxDays
     */
    public function __construct($minDays = null, $maxDays = null)
    {
        $this
            ->setMinDays($minDays)
            ->setMaxDays($maxDays);
    }
    /**
     * Get MinDays value
     * @return int
     */
    public function getMinDays()
    {
        return $this->MinDays;
    }
    /**
     * Set MinDays value
     * @param int $minDays
     * @return \Geniki\GenikiStruct\GenikiCalculateDayResult
     */
    public function setMinDays($minDays = null)
    {
        // validation for constraint: int
        if (!is_null($minDays) && !(is_int($minDays) || ctype_digit($minDays))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($minDays, true), gettype($minDays)), __LINE__);
        }
        $this->MinDays = $minDays;
        return $this;
    }
    /**
     * Get MaxDays value
     * @return int
     */
    public function getMaxDays()
    {
        return $this->MaxDays;
    }
    /**
     * Set MaxDays value
     * @param int $maxDays
     * @return \Geniki\GenikiStruct\GenikiCalculateDayResult
     */
    public function setMaxDays($maxDays = null)
    {
        // validation for constraint: int
        if (!is_null($maxDays) && !(is_int($maxDays) || ctype_digit($maxDays))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxDays, true), gettype($maxDays)), __LINE__);
        }
        $this->MaxDays = $maxDays;
        return $this;
    }
}
