<?php

namespace Geniki\GenikiStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Create3rdPartyShipper GenikiStruct
 * @package Geniki
 * @subpackage Structs
 */
class GenikiCreate3rdPartyShipper extends AbstractStructBase
{
    /**
     * The sAuthKey
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sAuthKey;
    /**
     * The shipperDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Geniki\GenikiStruct\GenikiThirdPartyShipperDetails
     */
    public $shipperDetails;
    /**
     * Constructor method for Create3rdPartyShipper
     * @uses GenikiCreate3rdPartyShipper::setSAuthKey()
     * @uses GenikiCreate3rdPartyShipper::setShipperDetails()
     * @param string $sAuthKey
     * @param \Geniki\GenikiStruct\GenikiThirdPartyShipperDetails $shipperDetails
     */
    public function __construct($sAuthKey = null, \Geniki\GenikiStruct\GenikiThirdPartyShipperDetails $shipperDetails = null)
    {
        $this
            ->setSAuthKey($sAuthKey)
            ->setShipperDetails($shipperDetails);
    }
    /**
     * Get sAuthKey value
     * @return string|null
     */
    public function getSAuthKey()
    {
        return $this->sAuthKey;
    }
    /**
     * Set sAuthKey value
     * @param string $sAuthKey
     * @return \Geniki\GenikiStruct\GenikiCreate3rdPartyShipper
     */
    public function setSAuthKey($sAuthKey = null)
    {
        // validation for constraint: string
        if (!is_null($sAuthKey) && !is_string($sAuthKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sAuthKey, true), gettype($sAuthKey)), __LINE__);
        }
        $this->sAuthKey = $sAuthKey;
        return $this;
    }
    /**
     * Get shipperDetails value
     * @return \Geniki\GenikiStruct\GenikiThirdPartyShipperDetails|null
     */
    public function getShipperDetails()
    {
        return $this->shipperDetails;
    }
    /**
     * Set shipperDetails value
     * @param \Geniki\GenikiStruct\GenikiThirdPartyShipperDetails $shipperDetails
     * @return \Geniki\GenikiStruct\GenikiCreate3rdPartyShipper
     */
    public function setShipperDetails(\Geniki\GenikiStruct\GenikiThirdPartyShipperDetails $shipperDetails = null)
    {
        $this->shipperDetails = $shipperDetails;
        return $this;
    }
}
