<?php

namespace Geniki\GenikiStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThirdPartyShipper GenikiStruct
 * @package Geniki
 * @subpackage Structs
 */
class GenikiThirdPartyShipper extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Active;
    /**
     * The CreatedOn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreatedOn;
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The CreationUid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CreationUid;
    /**
     * Constructor method for ThirdPartyShipper
     * @uses GenikiThirdPartyShipper::setActive()
     * @uses GenikiThirdPartyShipper::setCreatedOn()
     * @uses GenikiThirdPartyShipper::setCode()
     * @uses GenikiThirdPartyShipper::setCreationUid()
     * @param bool $active
     * @param string $createdOn
     * @param string $code
     * @param string $creationUid
     */
    public function __construct($active = null, $createdOn = null, $code = null, $creationUid = null)
    {
        $this
            ->setActive($active)
            ->setCreatedOn($createdOn)
            ->setCode($code)
            ->setCreationUid($creationUid);
    }
    /**
     * Get Active value
     * @return bool
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \Geniki\GenikiStruct\GenikiThirdPartyShipper
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get CreatedOn value
     * @return string
     */
    public function getCreatedOn()
    {
        return $this->CreatedOn;
    }
    /**
     * Set CreatedOn value
     * @param string $createdOn
     * @return \Geniki\GenikiStruct\GenikiThirdPartyShipper
     */
    public function setCreatedOn($createdOn = null)
    {
        // validation for constraint: string
        if (!is_null($createdOn) && !is_string($createdOn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdOn, true), gettype($createdOn)), __LINE__);
        }
        $this->CreatedOn = $createdOn;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Geniki\GenikiStruct\GenikiThirdPartyShipper
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get CreationUid value
     * @return string|null
     */
    public function getCreationUid()
    {
        return $this->CreationUid;
    }
    /**
     * Set CreationUid value
     * @param string $creationUid
     * @return \Geniki\GenikiStruct\GenikiThirdPartyShipper
     */
    public function setCreationUid($creationUid = null)
    {
        // validation for constraint: string
        if (!is_null($creationUid) && !is_string($creationUid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creationUid, true), gettype($creationUid)), __LINE__);
        }
        $this->CreationUid = $creationUid;
        return $this;
    }
}
