<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://voucher.taxydromiki.gr/JobServicesV2.asmx?WSDL',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://voucher.taxydromiki.gr/JobServicesV2.asmx?WSDL',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => \Geniki\GenikiClassMap::get(),
);
/**
 * Samples for Addrd ServiceType
 */
$addrd = new \Geniki\GenikiService\GenikiAddrd($options);
/**
 * Sample call for Add3rdPartyShipper operation/method
 */
if ($addrd->Add3rdPartyShipper(new \Geniki\GenikiStruct\GenikiAdd3rdPartyShipper()) !== false) {
    print_r($addrd->getResult());
} else {
    print_r($addrd->getLastError());
}
/**
 * Samples for Create ServiceType
 */
$create = new \Geniki\GenikiService\GenikiCreate($options);
/**
 * Sample call for CreateClientVoucherJob operation/method
 */
if ($create->CreateClientVoucherJob(new \Geniki\GenikiStruct\GenikiCreateClientVoucherJob()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateGroupedVoucherJob operation/method
 */
if ($create->CreateGroupedVoucherJob(new \Geniki\GenikiStruct\GenikiCreateGroupedVoucherJob()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateReturnRequest operation/method
 */
if ($create->CreateReturnRequest(new \Geniki\GenikiStruct\GenikiCreateReturnRequest()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateVoucherReturnRequest operation/method
 */
if ($create->CreateVoucherReturnRequest(new \Geniki\GenikiStruct\GenikiCreateVoucherReturnRequest()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateCODRelease operation/method
 */
if ($create->CreateCODRelease(new \Geniki\GenikiStruct\GenikiCreateCODRelease()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateVoucherPickupOrder operation/method
 */
if ($create->CreateVoucherPickupOrder(new \Geniki\GenikiStruct\GenikiCreateVoucherPickupOrder()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateVoucherReturnOrder operation/method
 */
if ($create->CreateVoucherReturnOrder(new \Geniki\GenikiStruct\GenikiCreateVoucherReturnOrder()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateJob operation/method
 */
if ($create->CreateJob(new \Geniki\GenikiStruct\GenikiCreateJob()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Samples for Update ServiceType
 */
$update = new \Geniki\GenikiService\GenikiUpdate($options);
/**
 * Sample call for UpdateReturnRequestParams operation/method
 */
if ($update->UpdateReturnRequestParams(new \Geniki\GenikiStruct\GenikiUpdateReturnRequestParams()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for UpdateVoucherPickupOrder operation/method
 */
if ($update->UpdateVoucherPickupOrder(new \Geniki\GenikiStruct\GenikiUpdateVoucherPickupOrder()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Samples for Get ServiceType
 */
$get = new \Geniki\GenikiService\GenikiGet($options);
/**
 * Sample call for GetReturnRequest operation/method
 */
if ($get->GetReturnRequest(new \Geniki\GenikiStruct\GenikiGetReturnRequest()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetReturnRequestOfVoucher operation/method
 */
if ($get->GetReturnRequestOfVoucher(new \Geniki\GenikiStruct\GenikiGetReturnRequestOfVoucher()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetReturnRequestPdf operation/method
 */
if ($get->GetReturnRequestPdf(new \Geniki\GenikiStruct\GenikiGetReturnRequestPdf()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetReturnRequestsPdf operation/method
 */
if ($get->GetReturnRequestsPdf(new \Geniki\GenikiStruct\GenikiGetReturnRequestsPdf()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherZPL operation/method
 */
if ($get->GetVoucherZPL(new \Geniki\GenikiStruct\GenikiGetVoucherZPL()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPickupOrder operation/method
 */
if ($get->GetVoucherPickupOrder(new \Geniki\GenikiStruct\GenikiGetVoucherPickupOrder()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetPickupJobStatus operation/method
 */
if ($get->GetPickupJobStatus(new \Geniki\GenikiStruct\GenikiGetPickupJobStatus()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherReturnOrder operation/method
 */
if ($get->GetVoucherReturnOrder(new \Geniki\GenikiStruct\GenikiGetVoucherReturnOrder()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherJob operation/method
 */
if ($get->GetVoucherJob(new \Geniki\GenikiStruct\GenikiGetVoucherJob()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetJobsFromOrderId operation/method
 */
if ($get->GetJobsFromOrderId(new \Geniki\GenikiStruct\GenikiGetJobsFromOrderId()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetJobs operation/method
 */
if ($get->GetJobs(new \Geniki\GenikiStruct\GenikiGetJobs()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPdf operation/method
 */
if ($get->GetVoucherPdf(new \Geniki\GenikiStruct\GenikiGetVoucherPdf()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersPdf operation/method
 */
if ($get->GetVouchersPdf(new \Geniki\GenikiStruct\GenikiGetVouchersPdf()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetShopsList operation/method
 */
if ($get->GetShopsList(new \Geniki\GenikiStruct\GenikiGetShopsList()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Track ServiceType
 */
$track = new \Geniki\GenikiService\GenikiTrack($options);
/**
 * Sample call for TrackDeliveryStatus operation/method
 */
if ($track->TrackDeliveryStatus(new \Geniki\GenikiStruct\GenikiTrackDeliveryStatus()) !== false) {
    print_r($track->getResult());
} else {
    print_r($track->getLastError());
}
/**
 * Sample call for TrackAndTrace operation/method
 */
if ($track->TrackAndTrace(new \Geniki\GenikiStruct\GenikiTrackAndTrace()) !== false) {
    print_r($track->getResult());
} else {
    print_r($track->getLastError());
}
/**
 * Samples for Createrd ServiceType
 */
$createrd = new \Geniki\GenikiService\GenikiCreaterd($options);
/**
 * Sample call for Create3rdPartyShipper operation/method
 */
if ($createrd->Create3rdPartyShipper(new \Geniki\GenikiStruct\GenikiCreate3rdPartyShipper()) !== false) {
    print_r($createrd->getResult());
} else {
    print_r($createrd->getLastError());
}
/**
 * Samples for Getrd ServiceType
 */
$getrd = new \Geniki\GenikiService\GenikiGetrd($options);
/**
 * Sample call for Get3rdPartyShipper operation/method
 */
if ($getrd->Get3rdPartyShipper(new \Geniki\GenikiStruct\GenikiGet3rdPartyShipper()) !== false) {
    print_r($getrd->getResult());
} else {
    print_r($getrd->getLastError());
}
/**
 * Samples for Cancel ServiceType
 */
$cancel = new \Geniki\GenikiService\GenikiCancel($options);
/**
 * Sample call for CancelVoucherPickupOrder operation/method
 */
if ($cancel->CancelVoucherPickupOrder(new \Geniki\GenikiStruct\GenikiCancelVoucherPickupOrder()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Sample call for CancelJob operation/method
 */
if ($cancel->CancelJob(new \Geniki\GenikiStruct\GenikiCancelJob()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Sample call for CancelAndCloseJob operation/method
 */
if ($cancel->CancelAndCloseJob(new \Geniki\GenikiStruct\GenikiCancelAndCloseJob()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Samples for Authenticate ServiceType
 */
$authenticate = new \Geniki\GenikiService\GenikiAuthenticate($options);
/**
 * Sample call for Authenticate operation/method
 */
if ($authenticate->Authenticate(new \Geniki\GenikiStruct\GenikiAuthenticate()) !== false) {
    print_r($authenticate->getResult());
} else {
    print_r($authenticate->getLastError());
}
/**
 * Samples for Add ServiceType
 */
$add = new \Geniki\GenikiService\GenikiAdd($options);
/**
 * Sample call for AddJobReport operation/method
 */
if ($add->AddJobReport(new \Geniki\GenikiStruct\GenikiAddJobReport()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for AddExtraInfo operation/method
 */
if ($add->AddExtraInfo(new \Geniki\GenikiStruct\GenikiAddExtraInfo()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Samples for Close ServiceType
 */
$close = new \Geniki\GenikiService\GenikiClose($options);
/**
 * Sample call for ClosePendingJobs operation/method
 */
if ($close->ClosePendingJobs(new \Geniki\GenikiStruct\GenikiClosePendingJobs()) !== false) {
    print_r($close->getResult());
} else {
    print_r($close->getLastError());
}
/**
 * Sample call for ClosePendingJobsByDate operation/method
 */
if ($close->ClosePendingJobsByDate(new \Geniki\GenikiStruct\GenikiClosePendingJobsByDate()) !== false) {
    print_r($close->getResult());
} else {
    print_r($close->getLastError());
}
/**
 * Samples for Change ServiceType
 */
$change = new \Geniki\GenikiService\GenikiChange($options);
/**
 * Sample call for ChangePassword operation/method
 */
if ($change->ChangePassword(new \Geniki\GenikiStruct\GenikiChangePassword()) !== false) {
    print_r($change->getResult());
} else {
    print_r($change->getLastError());
}
/**
 * Samples for Calculate ServiceType
 */
$calculate = new \Geniki\GenikiService\GenikiCalculate($options);
/**
 * Sample call for CalculateCost operation/method
 */
if ($calculate->CalculateCost(new \Geniki\GenikiStruct\GenikiCalculateCost()) !== false) {
    print_r($calculate->getResult());
} else {
    print_r($calculate->getLastError());
}
/**
 * Sample call for CalculateDay operation/method
 */
if ($calculate->CalculateDay(new \Geniki\GenikiStruct\GenikiCalculateDay()) !== false) {
    print_r($calculate->getResult());
} else {
    print_r($calculate->getLastError());
}
/**
 * Samples for Helper ServiceType
 */
$helper = new \Geniki\GenikiService\GenikiHelper($options);
/**
 * Sample call for Helper operation/method
 */
if ($helper->Helper(new \Geniki\GenikiStruct\GenikiHelper()) !== false) {
    print_r($helper->getResult());
} else {
    print_r($helper->getLastError());
}
/**
 * Samples for Echo ServiceType
 */
$echo = new \Geniki\GenikiService\GenikiEcho($options);
/**
 * Sample call for _Echo operation/method
 */
if ($echo->_Echo(new \Geniki\GenikiStruct\GenikiEcho()) !== false) {
    print_r($echo->getResult());
} else {
    print_r($echo->getLastError());
}
